import * as i1 from '@angular-three/core';
import { NgtComponentStore } from '@angular-three/core';
import { DOCUMENT } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Inject, Input, NgModule } from '@angular/core';
import Stats from 'three/examples/jsm/libs/stats.module';

class NgtStats extends NgtComponentStore {
    constructor(zone, store, { body }) {
        super();
        this.zone = zone;
        this.store = store;
        this.node = body;
    }
    ngOnInit() {
        this.zone.runOutsideAngular(() => {
            this.onCanvasReady(this.store.ready$, () => {
                if (this.parent) {
                    this.node = this.parent;
                }
                this.stats = Stats();
                this.node.appendChild(this.stats.dom);
                const unregister = this.store.registerBeforeRender({
                    callback: this.stats.update.bind(this.stats),
                });
                return () => {
                    if (this.stats) {
                        unregister();
                        this.stats.end();
                        this.node.removeChild(this.stats.dom);
                    }
                };
            }, true);
        });
    }
}
NgtStats.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: NgtStats, deps: [{ token: i0.NgZone }, { token: i1.NgtStore }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Component });
NgtStats.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.3", type: NgtStats, selector: "ngt-stats", inputs: { parent: "parent" }, usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: NgtStats, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-stats',
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], ctorParameters: function () { return [{ type: i0.NgZone }, { type: i1.NgtStore }, { type: Document, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; }, propDecorators: { parent: [{
                type: Input
            }] } });
class NgtStatsModule {
}
NgtStatsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: NgtStatsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtStatsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: NgtStatsModule, declarations: [NgtStats], exports: [NgtStats] });
NgtStatsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: NgtStatsModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.3", ngImport: i0, type: NgtStatsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [NgtStats],
                    exports: [NgtStats],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { NgtStats, NgtStatsModule };
//# sourceMappingURL=angular-three-core-stats.mjs.map
